Index: cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1676)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1693)
@@ -1,32 +1,32 @@
-unit ORCtrls;                                    // Oct 26, 1997 @ 10:00am
+unit ORCtrls; // Oct 26, 1997 @ 10:00am
 
 // To Do:  eliminate topindex itemtip on mousedown (seen when choosing clinic pts)
 
-interface  // --------------------------------------------------------------------------------
+interface // --------------------------------------------------------------------------------
 
 uses Windows, Messages, SysUtils, Classes, Graphics, Controls, StdCtrls, Forms,
-     ComCtrls, Commctrl, Buttons, ExtCtrls, Grids, ImgList, Menus, CheckLst,
-     Variants, VAClasses;
+  ComCtrls, Commctrl, Buttons, ExtCtrls, Grids, ImgList, Menus, CheckLst,
+  Variants, VAClasses, typinfo;
 
 const
-  UM_SHOWTIP  = (WM_USER + 9436);                // message id to display item tip         **was 300
-  UM_GOTFOCUS = (WM_USER + 9437);                // message to post when combo gets focus  **was 301
-  MAX_TABS = 40;                                 // maximum number of tab stops or pieces
-  LL_REVERSE  = -1;                              // long list scrolling in reverse direction
-  LL_POSITION =  0;                              // long list thumb moved
-  LL_FORWARD  =  1;                              // long list scrolling in forward direction
-  LLS_LINE  = '^____________________________________________________________________________';
-  LLS_DASH  = '^----------------------------------------------------------------------------';
+  UM_SHOWTIP = (WM_USER + 9436); // message id to display item tip         **was 300
+  UM_GOTFOCUS = (WM_USER + 9437); // message to post when combo gets focus  **was 301
+  MAX_TABS = 40; // maximum number of tab stops or pieces
+  LL_REVERSE = -1; // long list scrolling in reverse direction
+  LL_POSITION = 0; // long list thumb moved
+  LL_FORWARD = 1; // long list scrolling in forward direction
+  LLS_LINE = '^____________________________________________________________________________';
+  LLS_DASH = '^----------------------------------------------------------------------------';
   LLS_SPACE = '^ ';
 
 type
   IORBlackColorModeCompatible = interface(IInterface)
-  ['{3554985C-F524-45FA-8C27-4CDD8357DB08}']
+    ['{3554985C-F524-45FA-8C27-4CDD8357DB08}']
     procedure SetBlackColorMode(Value: boolean);
   end;
 
-  TORComboBox = class;                           // forward declaration for FParentCombo
-
-  TTranslator = function (MString: string): string of object;
+  TORComboBox = class; // forward declaration for FParentCombo
+
+  TTranslator = function(MString: string): string of object;
 
   TORStrings = class(TStrings)
@@ -38,10 +38,10 @@
     procedure Verify;
   protected
-    function Get( index:integer): string; override;
+    function Get(index: integer): string; override;
     function GetCount: integer; override;
-    function GetObject(index:integer): TObject; override;
+    function GetObject(index: integer): TObject; override;
     procedure Put(Index: Integer; const S: string); override;
-    procedure PutObject(index:integer; Value: TObject); override;
-    procedure SetUpdateState( Value: boolean); override;
+    procedure PutObject(index: integer; Value: TObject); override;
+    procedure SetUpdateState(Value: boolean); override;
   public
     function Add(const S: string): integer; override;
@@ -49,5 +49,5 @@
     destructor Destroy; override;
     procedure Clear; override;
-    procedure Delete( index: integer); override;
+    procedure Delete(index: integer); override;
     procedure Insert(Index: Integer; const S: string); override;
     function IndexOf(const S: string): Integer; override;
@@ -57,69 +57,74 @@
   end;
 
-  TORDirection = -1..1;                          // for compatibility, type is now integer
-  TORNeedDataEvent       = procedure(Sender: TObject; const StartFrom: string;
-                                     Direction, InsertAt: Integer) of object;
-  TORBeforeDrawEvent     = procedure(Sender: TObject; Index: Integer; Rect: TRect;
-                                     State: TOwnerDrawState) of object;
-  TORItemNotifyEvent     = procedure(Sender: TObject; Index: integer) of object;
+  TORDirection = -1..1; // for compatibility, type is now integer
+  TORNeedDataEvent = procedure(Sender: TObject; const StartFrom: string;
+    Direction, InsertAt: Integer) of object;
+  TORBeforeDrawEvent = procedure(Sender: TObject; Index: Integer; Rect: TRect;
+    State: TOwnerDrawState) of object;
+  TORItemNotifyEvent = procedure(Sender: TObject; Index: integer) of object;
   TORCheckComboTextEvent = procedure(Sender: TObject; NumChecked: integer; var Text: string) of object;
-  TORSynonymCheckEvent   = procedure(Sender: TObject; const Text: string;
-                                     var IsSynonym: boolean) of object;
+  TORSynonymCheckEvent = procedure(Sender: TObject; const Text: string;
+    var IsSynonym: boolean) of object;
 
   PItemRec = ^TItemRec;
   TItemRec = record
-    Reference: Variant;                          // variant value associated with item
-    UserObject: TObject;                         // Objects[n] property of listbox item
-    CheckedState: TCheckBoxState;                // Used to indicate check box values
+    Reference: Variant; // variant value associated with item
+    UserObject: TObject; // Objects[n] property of listbox item
+    CheckedState: TCheckBoxState; // Used to indicate check box values
+  end;
+
+  THintRecords = record
+    ObjectName: string;
+    ObjectHint: string;
   end;
 
   TORListBox = class(TListBox, IVADynamicProperty, IORBlackColorModeCompatible)
   private
-    FFocusIndex: Integer;                        // item with focus when using navigation keys
-    FLargeChange: Integer;                       // visible items less one
-    FTipItem: Integer;                           // item currently displaying ItemTip
-    FItemTipActive: Boolean;                     // used to delay appearance of the ItemTip
-    FItemTipColor: TColor;                       // background color for ItemTip window
-    FItemTipEnable: Boolean;                     // allows display of ItemTips over items
-    FLastMouseX: Integer;                        // mouse X position on last MouseMove event
-    FLastMouseY: Integer;                        // mouse Y position on last MouseMove event
-    FLastItemIndex: Integer;                     // used for the OnChange event
-    FFromSelf: Boolean;                          // true if listbox message sent from this unit
-    FDelimiter: Char;                            // delimiter used by Pieces property
-    FWhiteSpace: Char;                           // may be space or tab (between pieces)
-    FTabPosInPixels: boolean;                    // determines if TabPosition is Pixels or Chars
-    FTabPos: array[0..MAX_TABS] of Integer;      // character based positions of tab stops
-    FTabPix: array[0..MAX_TABS] of Integer;      // pixel positions of tab stops
-    FPieces: array[0..MAX_TABS] of Integer;      // pieces that should be displayed for item
-    FLongList: Boolean;                          // if true, enables special LongList properties
-    FScrollBar: TScrollBar;                      // scrollbar used when in LongList mode
-    FFirstLoad: Boolean;                         // true if NeedData has never been called
-    FFromNeedData: Boolean;                      // true means items added to LongList part
-    FDataAdded: Boolean;                         // true if items added during NeedData call
-    FCurrentTop: Integer;                        // TopIndex, changes when inserting to LongList
-    FWaterMark: Integer;                         // first LongList item after the short list
-    FDirection: Integer;                         // direction of the current NeedData call
-    FInsertAt: Integer;                          // insert point for the current NeedData call
-    FParentCombo: TORComboBox;                   // used when listbox is part of dropdown combo
-    FOnChange: TNotifyEvent;                     // event called when ItemIndex changes
-    FOnNeedData: TORNeedDataEvent;               // event called when LongList needs more items
-    FHideSynonyms: boolean;                      // Hides Synonyms from the list
-    FSynonymChars: string;                       // Chars a string must contain to be considered a synonym
-    FOnSynonymCheck: TORSynonymCheckEvent;       // Event that allows for custom synonym checking
-    FCreatingItem: boolean;                      // Used by Synonyms to prevent errors when adding new items
-    FCreatingText: string;                       // Used by Synonyms to prevent errors when adding new items
-    FOnBeforeDraw: TORBeforeDrawEvent;           // event called prior to drawing an item
-    FRightClickSelect: boolean;                  // When true, a right click selects teh item
-    FCheckBoxes: boolean;                        // When true, list box contains check boxes
-    FFlatCheckBoxes: boolean;                    // When true, list box check boxes are flat
-    FCheckEntireLine: boolean;                   // When checked, clicking anywhere on the line checks the checkbox
-    FOnClickCheck: TORItemNotifyEvent;           // Event notifying of checkbox change
-    FDontClose: boolean;                         // Used to keep drop down open when checkboxes
-    FItemsDestroyed: boolean;                    // Used to make sure items are not destroyed multiple times
+    FFocusIndex: Integer; // item with focus when using navigation keys
+    FLargeChange: Integer; // visible items less one
+    FTipItem: Integer; // item currently displaying ItemTip
+    FItemTipActive: Boolean; // used to delay appearance of the ItemTip
+    FItemTipColor: TColor; // background color for ItemTip window
+    FItemTipEnable: Boolean; // allows display of ItemTips over items
+    FLastMouseX: Integer; // mouse X position on last MouseMove event
+    FLastMouseY: Integer; // mouse Y position on last MouseMove event
+    FLastItemIndex: Integer; // used for the OnChange event
+    FFromSelf: Boolean; // true if listbox message sent from this unit
+    FDelimiter: Char; // delimiter used by Pieces property
+    FWhiteSpace: Char; // may be space or tab (between pieces)
+    FTabPosInPixels: boolean; // determines if TabPosition is Pixels or Chars
+    FTabPos: array[0..MAX_TABS] of Integer; // character based positions of tab stops
+    FTabPix: array[0..MAX_TABS] of Integer; // pixel positions of tab stops
+    FPieces: array[0..MAX_TABS] of Integer; // pieces that should be displayed for item
+    FLongList: Boolean; // if true, enables special LongList properties
+    FScrollBar: TScrollBar; // scrollbar used when in LongList mode
+    FFirstLoad: Boolean; // true if NeedData has never been called
+    FFromNeedData: Boolean; // true means items added to LongList part
+    FDataAdded: Boolean; // true if items added during NeedData call
+    FCurrentTop: Integer; // TopIndex, changes when inserting to LongList
+    FWaterMark: Integer; // first LongList item after the short list
+    FDirection: Integer; // direction of the current NeedData call
+    FInsertAt: Integer; // insert point for the current NeedData call
+    FParentCombo: TORComboBox; // used when listbox is part of dropdown combo
+    FOnChange: TNotifyEvent; // event called when ItemIndex changes
+    FOnNeedData: TORNeedDataEvent; // event called when LongList needs more items
+    FHideSynonyms: boolean; // Hides Synonyms from the list
+    FSynonymChars: string; // Chars a string must contain to be considered a synonym
+    FOnSynonymCheck: TORSynonymCheckEvent; // Event that allows for custom synonym checking
+    FCreatingItem: boolean; // Used by Synonyms to prevent errors when adding new items
+    FCreatingText: string; // Used by Synonyms to prevent errors when adding new items
+    FOnBeforeDraw: TORBeforeDrawEvent; // event called prior to drawing an item
+    FRightClickSelect: boolean; // When true, a right click selects teh item
+    FCheckBoxes: boolean; // When true, list box contains check boxes
+    FFlatCheckBoxes: boolean; // When true, list box check boxes are flat
+    FCheckEntireLine: boolean; // When checked, clicking anywhere on the line checks the checkbox
+    FOnClickCheck: TORItemNotifyEvent; // Event notifying of checkbox change
+    FDontClose: boolean; // Used to keep drop down open when checkboxes
+    FItemsDestroyed: boolean; // Used to make sure items are not destroyed multiple times
     FAllowGrayed: boolean;
-    FMItems: TORStrings;                         // Used to save corresponding M strings ("the pieces")
-    FCaption: TStaticText;                       // Used to supply a title to IAccessible interface
-    FCaseChanged: boolean;                       // If true, the names are stored in the database as all caps, but loaded and displayed in mixed-case
-    FLookupPiece: integer;                       // If zero, list look-up comes from display string; if non-zero, indicates which piece of the item needs to be used for list lookup
+    FMItems: TORStrings; // Used to save corresponding M strings ("the pieces")
+    FCaption: TStaticText; // Used to supply a title to IAccessible interface
+    FCaseChanged: boolean; // If true, the names are stored in the database as all caps, but loaded and displayed in mixed-case
+    FLookupPiece: integer; // If zero, list look-up comes from display string; if non-zero, indicates which piece of the item needs to be used for list lookup
     FIsPartOfComboBox: boolean;
     FBlackColorMode: boolean;
@@ -156,27 +161,27 @@
     function IsSynonym(const TestStr: string): boolean;
     function TextToShow(S: string): string;
-    procedure LBGetText      (var Message: TMessage);         message LB_GETTEXT;
-    procedure LBGetTextLen   (var Message: TMessage);         message LB_GETTEXTLEN;
-    procedure LBGetItemData  (var Message: TMessage);         message LB_GETITEMDATA;
-    procedure LBSetItemData  (var Message: TMessage);         message LB_SETITEMDATA;
-    procedure LBAddString    (var Message: TMessage);         message LB_ADDSTRING;
-    procedure LBInsertString (var Message: TMessage);         message LB_INSERTSTRING;
-    procedure LBDeleteString (var Message: TMessage);         message LB_DELETESTRING;
-    procedure LBResetContent (var Message: TMessage);         message LB_RESETCONTENT;
-    procedure LBSetCurSel    (var Message: TMessage);         message LB_SETCURSEL;
-    procedure CMFontChanged  (var Message: TMessage);         message CM_FONTCHANGED;
-    procedure CNDrawItem     (var Message: TWMDrawItem);      message CN_DRAWITEM;
-    procedure WMDestroy      (var Message: TWMDestroy);       message WM_DESTROY;
-    procedure WMKeyDown      (var Message: TWMKeyDown);       message WM_KEYDOWN;
-    procedure WMLButtonDown  (var Message: TWMLButtonDown);   message WM_LBUTTONDOWN;
-    procedure WMLButtonUp    (var Message: TWMLButtonUp);     message WM_LBUTTONUP;
-    procedure WMRButtonUp    (var Message: TWMRButtonUp);     message WM_RBUTTONUP;
+    procedure LBGetText(var Message: TMessage); message LB_GETTEXT;
+    procedure LBGetTextLen(var Message: TMessage); message LB_GETTEXTLEN;
+    procedure LBGetItemData(var Message: TMessage); message LB_GETITEMDATA;
+    procedure LBSetItemData(var Message: TMessage); message LB_SETITEMDATA;
+    procedure LBAddString(var Message: TMessage); message LB_ADDSTRING;
+    procedure LBInsertString(var Message: TMessage); message LB_INSERTSTRING;
+    procedure LBDeleteString(var Message: TMessage); message LB_DELETESTRING;
+    procedure LBResetContent(var Message: TMessage); message LB_RESETCONTENT;
+    procedure LBSetCurSel(var Message: TMessage); message LB_SETCURSEL;
+    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
+    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
+    procedure WMDestroy(var Message: TWMDestroy); message WM_DESTROY;
+    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
+    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
+    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
+    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
     procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
-    procedure WMCancelMode   (var Message: TMessage);         message WM_CANCELMODE;
-    procedure WMMove         (var Message: TWMMove);          message WM_MOVE;
-    procedure WMSize         (var Message: TWMSize);          message WM_SIZE;
-    procedure WMVScroll      (var Message: TWMVScroll);       message WM_VSCROLL;
-    procedure CMHintShow     (var Message: TMessage);         message CM_HINTSHOW;
-    procedure UMShowTip      (var Message: TMessage);         message UM_SHOWTIP;
+    procedure WMCancelMode(var Message: TMessage); message WM_CANCELMODE;
+    procedure WMMove(var Message: TWMMove); message WM_MOVE;
+    procedure WMSize(var Message: TWMSize); message WM_SIZE;
+    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
+    procedure CMHintShow(var Message: TMessage); message CM_HINTSHOW;
+    procedure UMShowTip(var Message: TMessage); message UM_SHOWTIP;
     function GetChecked(Index: Integer): Boolean;
     procedure SetChecked(Index: Integer; const Value: Boolean);
@@ -187,5 +192,5 @@
     procedure SetCheckedState(Index: Integer; const Value: TCheckBoxState);
     function GetMItems: TStrings;
-    procedure SetMItems( Value: TStrings);
+    procedure SetMItems(Value: TStrings);
     procedure SetCaption(const Value: string);
     function GetCaption: string;
@@ -207,5 +212,5 @@
     procedure MeasureItem(Index: Integer; var Height: Integer); override;
     procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
-    function GetIndexFromY(YPos :integer) :integer;
+    function GetIndexFromY(YPos: integer): integer;
     property isPartOfComboBox: boolean read FIsPartOfComboBox write FIsPartOfComboBox default False;
     property HideSynonyms: boolean read FHideSynonyms write SetHideSynonyms default FALSE;
@@ -236,8 +241,9 @@
     property CheckedState[Index: Integer]: TCheckBoxState read GetCheckedState write SetCheckedState;
     property MItems: TStrings read GetMItems write SetMItems;
-    function VerifyUnique(SelectIndex: Integer; iText: String): integer;
+    function VerifyUnique(SelectIndex: Integer; iText: string): integer;
     procedure SetBlackColorMode(Value: boolean);
     function SupportsDynamicProperty(PropertyID: integer): boolean;
     function GetDynamicProperty(PropertyID: integer): string;
+    procedure SetHintProperties(Restore: Boolean; MainForm: TComponent);
     property HideSelection: boolean read FHideSelection write FHideSelection;
   published
@@ -303,42 +309,43 @@
   TORComboBox = class(TWinControl, IVADynamicProperty, IORBlackColorModeCompatible)
   private
-    FItems: TStrings;                            // points to Items in FListBox
-    FMItems: TStrings;                           // points to MItems in FListBox
-    FListBox: TORListBox;                        // listbox control for the combobox
-    FEditBox: TORComboEdit;                      // edit control for the combobox
-    FEditPanel: TORComboPanelEdit;               // Used to enable Multi-Select Combo Boxes
-    FDropBtn: TBitBtn;                           // drop down button for dropdown combo
-    FDropPanel: TORDropPanel;                    // panel for dropdown combo (parent=desktop)
-    FDroppedDown: Boolean;                       // true if the list part is dropped down
-    FStyle: TORComboStyle;                       // style is simple or dropdown for combo
-    FDropDownCount: Integer;                     // number of items to display when list appears
-    FFromSelf: Boolean;                          // prevents recursive calls to change event
-    FFromDropBtn: Boolean;                       // determines when to capture mouse on drop
-    FKeyTimerActive: Boolean;                    // true when timer running for OnKeyPause
-    FKeyIsDown: Boolean;                         // true between KeyDown & KeyUp events
+    FItems: TStrings; // points to Items in FListBox
+    FMItems: TStrings; // points to MItems in FListBox
+    FListBox: TORListBox; // listbox control for the combobox
+    FEditBox: TORComboEdit; // edit control for the combobox
+    FEditPanel: TORComboPanelEdit; // Used to enable Multi-Select Combo Boxes
+    FDropBtn: TBitBtn; // drop down button for dropdown combo
+    FDropPanel: TORDropPanel; // panel for dropdown combo (parent=desktop)
+    FDroppedDown: Boolean; // true if the list part is dropped down
+    FStyle: TORComboStyle; // style is simple or dropdown for combo
+    FDropDownCount: Integer; // number of items to display when list appears
+    FFromSelf: Boolean; // prevents recursive calls to change event
+    FFromDropBtn: Boolean; // determines when to capture mouse on drop
+    FKeyTimerActive: Boolean; // true when timer running for OnKeyPause
+    FKeyIsDown: Boolean; // true between KeyDown & KeyUp events
     FChangePending: Boolean;
     FListItemsOnly: Boolean;
     FLastFound: string;
-    FLastInput: string;                          // last thing the user typed into the edit box
-    FOnChange: TNotifyEvent;                     // maps to editbox change event
-    FOnClick: TNotifyEvent;                      // maps to listbox click event
-    FOnDblClick: TNotifyEvent;                   // maps to listbox double click event
-    FOnDropDown: TNotifyEvent;                   // event called when listbox appears
-    FOnDropDownClose: TNotifyEvent;              // event called when listbox disappears
-    FOnKeyDown: TKeyEvent;                       // maps to editbox keydown event
-    FOnKeyPress: TKeyPressEvent;                 // maps to editbox keypress event
-    FOnKeyUp: TKeyEvent;                         // maps to editbox keyup event
-    FOnKeyPause: TNotifyEvent;                   // delayed change event when using keyboard
-    FOnMouseClick: TNotifyEvent;                 // called when click event triggered by mouse
-    FOnNeedData: TORNeedDataEvent;               // called for longlist when more items needed
-    FCheckedState: string;                       // Used to refresh checkboxes when combo box cancel is pressed
-    FOnCheckedText: TORCheckComboTextEvent;      // Used to modify the edit box display text when using checkboxes
-    FCheckBoxEditColor: TColor;                  // Edit Box color for Check Box Combo List, when not in Focus
+    FLastInput: string; // last thing the user typed into the edit box
+    FOnChange: TNotifyEvent; // maps to editbox change event
+    FOnClick: TNotifyEvent; // maps to listbox click event
+    FOnDblClick: TNotifyEvent; // maps to listbox double click event
+    FOnDropDown: TNotifyEvent; // event called when listbox appears
+    FOnDropDownClose: TNotifyEvent; // event called when listbox disappears
+    FOnKeyDown: TKeyEvent; // maps to editbox keydown event
+    FOnKeyPress: TKeyPressEvent; // maps to editbox keypress event
+    FOnKeyUp: TKeyEvent; // maps to editbox keyup event
+    FOnKeyPause: TNotifyEvent; // delayed change event when using keyboard
+    FOnMouseClick: TNotifyEvent; // called when click event triggered by mouse
+    FOnNeedData: TORNeedDataEvent; // called for longlist when more items needed
+    FCheckedState: string; // Used to refresh checkboxes when combo box cancel is pressed
+    FOnCheckedText: TORCheckComboTextEvent; // Used to modify the edit box display text when using checkboxes
+    FCheckBoxEditColor: TColor; // Edit Box color for Check Box Combo List, when not in Focus
     FTemplateField: boolean;
-    FCharsNeedMatch: integer;                    // how many text need to be matched for auto selection
-    FUniqueAutoComplete: Boolean;                // If true only perform autocomplete for unique list items.
+    FCharsNeedMatch: integer; // how many text need to be matched for auto selection
+    FUniqueAutoComplete: Boolean; // If true only perform autocomplete for unique list items.
     FBlackColorMode: boolean;
-    FDisableHints: boolean;                      // true if hints have been disabled because drop down window was opened
-    FDropDownStatusChangedCount: integer;        // prevents multiple calls to disabling hint window
+    FDisableHints: boolean; // true if hints have been disabled because drop down window was opened
+    FDropDownStatusChangedCount: integer; // prevents multiple calls to disabling hint window
+    fRpcCall: String;
     procedure DropDownStatusChanged(opened: boolean);
     procedure ClearDropDownStatus;
@@ -413,10 +420,10 @@
     procedure StartKeyTimer;
     procedure StopKeyTimer;
-    procedure WMDestroy     (var Message: TWMDestroy); message WM_DESTROY;
-    procedure CMFontChanged (var Message: TMessage); message CM_FONTCHANGED;
-    procedure WMMove        (var Message: TWMMove);  message WM_MOVE;
-    procedure WMSize        (var Message: TWMSize);  message WM_SIZE;
-    procedure WMTimer       (var Message: TWMTimer); message WM_TIMER;
-    procedure UMGotFocus    (var Message: TMessage); message UM_GOTFOCUS;
+    procedure WMDestroy(var Message: TWMDestroy); message WM_DESTROY;
+    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
+    procedure WMMove(var Message: TWMMove); message WM_MOVE;
+    procedure WMSize(var Message: TWMSize); message WM_SIZE;
+    procedure WMTimer(var Message: TWMTimer); message WM_TIMER;
+    procedure UMGotFocus(var Message: TMessage); message UM_GOTFOCUS;
     function GetCheckBoxes: boolean;
     function GetChecked(Index: Integer): Boolean;
@@ -464,5 +471,5 @@
     procedure InsertSeparator;
     procedure Invalidate; override;
-    procedure SetTextAutoComplete(TextToMatch : String);
+    procedure SetTextAutoComplete(TextToMatch: string);
     function GetIEN(AnIndex: Integer): Int64;
     function SelectByIEN(AnIEN: Int64): Integer;
@@ -490,4 +497,5 @@
     property MItems: TStrings read GetMItems;
   published
+    Property RpcCall :String read fRpcCall write fRpcCall;
     property Anchors;
     property CaseChanged: boolean read GetCaseChanged write SetCaseChanged default TRUE;
@@ -548,5 +556,5 @@
     property OnResize;
     property OnSynonymCheck: TORSynonymCheckEvent read GetOnSynonymCheck write SetOnSynonymCheck;
-    property CharsNeedMatch: integer  read FCharsNeedMatch  write SetNumForMatch;
+    property CharsNeedMatch: integer read FCharsNeedMatch write SetNumForMatch;
 {UniqueAutoComplete Was added as a result of the following defects:
  7293 - PTM 85:  Backspace and Dosage:  Desired dosage does not populate if dosage is not in local dosage field
@@ -560,6 +568,6 @@
   private
     FSizes: TList;
-    procedure BuildSizes( Control: TWinControl);
-    procedure DoResize( Control: TWinControl; var CurrentIndex: Integer);
+    procedure BuildSizes(Control: TWinControl);
+    procedure DoResize(Control: TWinControl; var CurrentIndex: Integer);
   protected
     procedure Loaded; override;
@@ -569,9 +577,9 @@
   end;
 
-  TOROffsetLabel = class(TGraphicControl)        // see TCustomLabel in the VCL
+  TOROffsetLabel = class(TGraphicControl) // see TCustomLabel in the VCL
   private
-    FHorzOffset: Integer;                        // offset from left of label in pixels
-    FVertOffset: Integer;                        // offset from top of label in pixels
-    FWordWrap: Boolean;                          // true if word wrap should occur
+    FHorzOffset: Integer; // offset from left of label in pixels
+    FVertOffset: Integer; // offset from top of label in pixels
+    FWordWrap: Boolean; // true if word wrap should occur
     function GetTransparent: Boolean;
     procedure AdjustSizeOfSelf;
@@ -648,5 +656,5 @@
   end;
 
-  TORAlignEdit =  class(TEdit)  //Depricated -- Use TCaptionEdit instead
+  TORAlignEdit = class(TEdit) //Depricated -- Use TCaptionEdit instead
   published
     property Align;
@@ -722,12 +730,12 @@
     constructor Create(AOwner: TComponent); override;
     function FindPieceNode(Value: string;
-                           ParentDelim: Char = #0; StartNode: TTreeNode = nil): TORTreeNode; overload;
+      ParentDelim: Char = #0; StartNode: TTreeNode = nil): TORTreeNode; overload;
     function FindPieceNode(Value: string; APiece: integer;
-                           ParentDelim: Char = #0; StartNode: TTreeNode = nil): TORTreeNode; overload;
+      ParentDelim: Char = #0; StartNode: TTreeNode = nil): TORTreeNode; overload;
     procedure RenameNodes;
     function GetExpandedIDStr(APiece: integer; ParentDelim: char = #0): string;
     procedure SetExpandedIDStr(APiece: integer; const Value: string); overload;
     procedure SetExpandedIDStr(APiece: integer; ParentDelim: char;
-                                                const Value: string); overload;
+      const Value: string); overload;
     function GetNodeID(Node: TORTreeNode; ParentDelim: Char = #0): string; overload;
     function GetNodeID(Node: TORTreeNode; APiece: integer; ParentDelim: Char = #0): string; overload;
@@ -770,9 +778,9 @@
     destructor Destroy; override;
   published
-    property CheckedEnabledIndex:    integer read FCheckedEnabledIndex    write SetCheckedEnabledIndex;
-    property CheckedDisabledIndex:   integer read FCheckedDisabledIndex   write SetCheckedDisabledIndex;
-    property GrayedEnabledIndex:     integer read FGrayedEnabledIndex     write SetGrayedEnabledIndex;
-    property GrayedDisabledIndex:    integer read FGrayedDisabledIndex    write SetGrayedDisabledIndex;
-    property UncheckedEnabledIndex:  integer read FUncheckedEnabledIndex  write SetUncheckedEnabledIndex;
+    property CheckedEnabledIndex: integer read FCheckedEnabledIndex write SetCheckedEnabledIndex;
+    property CheckedDisabledIndex: integer read FCheckedDisabledIndex write SetCheckedDisabledIndex;
+    property GrayedEnabledIndex: integer read FGrayedEnabledIndex write SetGrayedEnabledIndex;
+    property GrayedDisabledIndex: integer read FGrayedDisabledIndex write SetGrayedDisabledIndex;
+    property UncheckedEnabledIndex: integer read FUncheckedEnabledIndex write SetUncheckedEnabledIndex;
     property UncheckedDisabledIndex: integer read FUncheckedDisabledIndex write SetUncheckedDisabledIndex;
   end;
